#
# Licensed Materials - Property of IBM
# Rational ClearCase
# (C) Copyright IBM Corp. 1998, 2005. All Rights Reserved
# US Government Users Restricted Rights
# Use, duplication or disclosure restricted by GSA ADP Schedule Contract with 
# IBM Corp
#

# Figure out which architecture we're on. The Config.pm package and $^O Perl 
# variable both have changed depending on the version of perl or ccperl that 
# actually runs this script, so we need to try a couple of combinations.
use Config;
my $arch = $^O ? $^O : $main::Config{archname};
$CFG::NT = (($arch =~ /^MSWin32/) || ($arch eq 'i386-win32')) ? 1 : 0;
$CFG::UNIX = ($CFG::NT ? 0 : 1);
# CLEARCASEHOME e.v. should always be set on NT when called by ccperlpp.pl,
# so exit if it's not set. On UNIX, assume /opt/rational/clearcase.
if ($CFG::UNIX) {
    if (!exists $ENV{CLEARCASEHOME}) {
        # check for (now deprecated) ATRIAHOME e.v.; use if set.
        if (exists $ENV{ATRIAHOME} ) {
	    $ENV{CLEARCASEHOME} = $ENV{ATRIAHOME};
        } else {
            $ENV{CLEARCASEHOME} = "/opt/rational/clearcase";
        }
    }
    my $producthome = $ENV{CLEARCASEHOME};

    chdir $producthome;
    push(@INC, "$producthome/config/scheduler/tasks");
    $sync_export = "bin/Perl config/scheduler/tasks/sync_export_list.bat";
# 
# Find the configuration file
# First check /var/adm/rational/clearcase/config
   if(-f "/var/adm/rational/clearcase/config/rfm_shipping.conf") {
	$cfile = "/var/adm/rational/clearcase/config/rfm_shipping.conf";
   }
} else {
    if (!exists $ENV{CLEARCASEHOME}) {
        # check for (now deprecated) ATRIAHOME e.v.; use if set.
        if (exists $ENV{ATRIAHOME} ) {
	    $ENV{CLEARCASEHOME} = $ENV{ATRIAHOME};
        } else {
            die "CLEARCASEHOME (or ATRIAHOME) env. variable not set\n";
        }
    }

    $ENV{ATRIAHOME} = $ENV{CLEARCASEHOME};

    my $producthome = $ENV{CLEARCASEHOME};

    chdir $producthome;
    push(@INC, "$producthome\\config\\scheduler\\tasks");
    $sync_export = "config\\scheduler\\tasks\\sync_export_list.bat";
    $cfile = "var/config/rfm_shipping.conf";
}
#
# Read the configration file
#
open(CONF_FD, $cfile);
@clines = <CONF_FD>;
close(CONF_FD);
foreach $l (@clines) {
    $l =~ s/^\s+//o;           #eliminate leading white-space
    next if( $l =~ m/^#.*/o );    #skip comments
    next if( $l =~ m/^\s*$/o);   #skip blank lines
    chop $l;
    if($l =~ /RFM_OPTIONAL_ARGUMENTS/) {
	($optargs = $l) =~ s/.*=//;
	last;
    }
}
if ($CFG::UNIX) {
    $argv = join(' ',@ARGV);
    $ret = system("$sync_export $argv $optargs &");
}
else {
    @opts = split(' ',$optargs);
    $ret = system("$sync_export", @ARGV, @opts);
}
